var main_tizen = {
}
var player = null;
var transfer = false;
var manager = false;
var nodeJS_started = 0;
var service_timer = false;
$(document).ready(function(){	
	try{
		var systemInfo = navigator.userAgent || navigator.vendor || window.opera;
		systemInfo = systemInfo.toLowerCase();
		var tizen_version = systemInfo.substring(systemInfo.lastIndexOf("tizen"),systemInfo.lastIndexOf("tizen")+11);
		tizen_version = parseInt(tizen_version.substring(tizen_version.length-5,tizen_version.length));
		if(tizen_version > 3){
			try{
				b2bapis.b2bcontrol.startNodeServer("../server.js", "SSSPServer", function(){
					$("#starter").html("[Initial Boot] success ");
					nodeJS_started = 1;
					startApp();
				},function(error){
					$("#starter").html("[Initial Boot] code :" + error.code + " error name: " + error.name + "  message " + error.message);
					nodeJS_started = -1;
					startApp();
				});
			}catch(e){
				$("#starter").html("[Initial Boot] Exception");
				nodeJS_started = -1;
				startApp();
			}
		}else if(tizen_version > 2){
			startApp();
		}else{
			startApp();
		}
	}catch(e){
		startApp();
	}
});

function startApp(){
	try{
		$("#starter").html("NodeJS Status : "+nodeJS_started);
		tizen.tvinputdevice.registerKey('0');
		tizen.tvinputdevice.registerKey('1');
		document.addEventListener('keydown', self.onKeyDown, false);
		$.get('file:///opt/usr/media/Documents/app/tizen.html', function(data, status) {
			$("#starter").html("File request status: "+status);
		}).done(function() {
			$("#starter").html("System is updatable.");
			$.get('file:///opt/usr/media/Documents/url.ver', function(dataURL, status) {
				$.get('file:///opt/usr/apps/9A3yAedyAS/res/wgt/admira.ver', function(dataURLi, status) {
					dataURL = dataURL.replace(/[^a-zA-Z0-9]/g, '');
					dataURLi = dataURLi.replace(/[^a-zA-Z0-9]/g, '');
					if(dataURL != dataURLi && dataURLi != "debug"){
						$("#starter").html("Different App version found, must update -- dataURL: "+dataURL+ " dataURLi:"+dataURLi);
						initApplication();
					}else{
						$("#starter").html("Same version, all good.");
						document.location ="file:///opt/usr/media/Documents/app/tizen.html";
					}
				}).fail(function() {
					$("#starter").html("Could not get : admira.ver");
					initApplication();
				});
			}).fail(function() {
				$("#starter").html("Could not get : url.ver");
				initApplication();
			});
		}).fail(function(e) {
			$.get('file:///opt/usr/home/owner/content/Documents/app/tizen.html', function(data, status) {
				$("#starter").html("File request status: "+status);
			}).done(function() {
				$("#starter").html("System is updatable.");
				$.get('file:///opt/usr/home/owner/content/Documents/url.ver', function(dataURL, status) {
					$.get('file:///opt/usr/home/owner/apps_rw/9A3yAedyAS/res/wgt/admira.ver', function(dataURLi, status) {
						dataURL = dataURL.replace(/[^a-zA-Z0-9]/g, '');
						dataURLi = dataURLi.replace(/[^a-zA-Z0-9]/g, '');
						if(dataURL != dataURLi && dataURLi != "debug"){
							$("#starter").html("Different App version found, must update -- dataURL: "+dataURL+ " dataURLi:"+dataURLi);
							initApplication();
						}
						else{
							$("#starter").html("Same version, all good.");
							document.location ="file:///opt/usr/home/owner/content/Documents/app/tizen.html";
						}
					}).fail(function() {
						$("#starter").html("Could not get : admira.ver");
						initApplication();
					});
				}).fail(function() {
					$("#starter").html("Could not get : url.ver");
					initApplication();
				});
			}).fail(function(e) {
				$("#starter").html("Has no external installation");
				initApplication();
			});
		});
	}catch(e){
		initApplication();
	}
}

function initApplication(){
	try{
		if(!player){
			player = new PlayerController();
			$(player).on("PlayerDataLoaded",onPlayerDataLoaded);
			player.init();
		}
	}catch(e){
		$("#starter").html("System in recovery mode.");
		try{
			if(!transfer){
	        transfer = new TransferService();
	        transfer.setTimeCallback = player.setUseServerTime;
	        transfer.init(player.version,player.platform);
	    }
			transfer.activateLogger(player.debug);
	    transfer.update(player.timestamp);
		}catch(e){
			console.log("Unable to start transfer");
		}
		try{
			schedule = player.config.getScheduleConfig();
		}catch(e){
			console.log("No Schedule !");
		}
		try{
			if(!manager){
	        manager = new ManagerService();
	        manager.init();
					try{
						transfer.onUpdatedManagerInterval = function(interval){
							console.log("Checking ManagerService Interval");
							manager.checkInterval(interval);
						};
					}catch(e){
						console.log("Could not check interval for management");
					}
	    }
			manager.activateLogger(player.debug);
	    manager.update(schedule);
		}catch(e){
			console.log("Unable to start manager");
		}
	}
}

function onPlayerDataLoaded(){
	player.OS.updateURL(function(err_updateURL,result_updateURL){
		try{
			if(!transfer){
					transfer = new TransferService();
					transfer.setTimeCallback = player.setUseServerTime;
					transfer.init(player.version,player.platform);
			}
			transfer.activateLogger(player.debug);
			transfer.update(player.timestamp);
		}catch(e){
			console.log("Unable to start transfer");
		}
		try{
			schedule = player.config.getScheduleConfig();
		}catch(e){
			console.log("No Schedule !");
		}
		try{
			if(!manager){
					manager = new ManagerService();
					manager.init();
					try{
						transfer.onUpdatedManagerInterval = function(interval){
							console.log("Checking ManagerService Interval");
							manager.checkInterval(interval);
						};
					}catch(e){
						console.log("Could not check interval for management");
					}
			}
			manager.activateLogger(player.debug);
			manager.update(schedule);
		}catch(e){
			console.log("Unable to start manager");
		}
    setTimeout(function(){
    	if(!timerService){
    		timerService = new TimerService();
    	}
    	timerService.checkTimers(schedule);
    }, 15000);
	});
	if(!service_timer){
			service_timer = setInterval(service,10000);
	}
}

function service(){
	if(player){
		player.service();
		try{
			if(transfer){
					transfer.updateInfo(player.name,player.getInfo());
			}
		}catch(e){
			console.log("Unable to update player info for transfer");
		}
	}
}

this.onKeyDown = function (event) {
	"use strict";
	var keyCode = event.keyCode;

	switch (keyCode) {
			case 37:
					player.playlist.jump(-1);
					break;
			case 39:
					player.playlist.jump();
					break;
			case 49:
					player.toggleCoreSetupWindow();
					break;
			case 50:
          player.toggleProxySetupWindow();
          break;
	    case 48:    // MediaPause
				player.debug = !player.debug;
				try{
					player.setLogger($("#playerLog"));
					player.activateLogger(player.debug);
				}catch(e){
					console.log("Error on player toggle debug");
				}
				try{
					transfer.setLogger($("#transferLog"));
					transfer.activateLogger(player.debug);
					manager.setLogger($("#transferLog"));
				}catch(e){
					console.log("Error on transfer toggle debug");
				}
	    break;
			
		default:
			player.log(keyCode);
		break;
	}
};
